#include "AutomobiliuSarasas.h"
#include <iostream>

// *****************************************************************************
void AutomobiliuSarasas::addAuto (Automobilis* automobilis) {
    automobiliai.push_back(automobilis);
}
// *****************************************************************************
void AutomobiliuSarasas::printAutoSarasasSuSumineInfo() {
    
    vector<Automobilis*>::iterator iter = automobiliai.begin();
    cout << "--------------------------------------------------" << endl;
    cout << "Pavadinimas"   << " " << setw(10) 
         << "| Valst. nr."  << " " << setw(10)
         << "| Remontu sk." << " " << setw(10)
         << "| Kaina"       << " " << setw(10) << endl;
    cout << "--------------------------------------------------" << endl;
    
    for (; iter != automobiliai.end(); iter++) {
        cout << (*iter)->getPavadinimas()        << " " << setw(13)
             << (*iter)->getValstNr()            << " " << setw(10)
             << (*iter)->kiekRemontuotas()       << " " << setprecision(2) << setw(10)
             << (*iter)->getKiekIsleistaPinigu() << endl;
    }
    system("pause");
}
// *****************************************************************************
void AutomobiliuSarasas::printVienoAutoDarbuIstorija() {
    printSarasas();
    
    if (automobiliai.size() != 0) {
        int pasirinkimas = getPasirinkimas(1, (int)automobiliai.size());
        Automobilis* automobilis = automobiliai[pasirinkimas - 1];
        cout << automobilis->getPavadinimas() << " " << automobilis->getValstNr() << " ";
        automobilis->printDarbuIstorija();
    }
    else cout << "Sarasas tuscias!!!" << endl; 
    system("pause");
}
// *****************************************************************************
void AutomobiliuSarasas::printSarasas () {

    cout << "   Automobiliu sarasas" << endl;
    cout << "-----------------------------------" << endl; 
    cout << "Pavadinimas   | Valstybinis numeris" << endl; 
    cout << "-----------------------------------" << endl; 
    
    vector<Automobilis*>::iterator iter = automobiliai.begin();
    
    for (int i = 1; iter != automobiliai.end(); i++, iter++) {
        cout << i << ". " << (*iter)->getPavadinimas() << " " << setw(10)
                          << (*iter)->getValstNr()     << endl;
    }
}
// *****************************************************************************
int AutomobiliuSarasas::getPasirinkimas (int min, int max) {
    int pasirinkimas;
    do
    {
        cout << "Koki nr pasirenkate?" << endl;
        cin >> pasirinkimas;
    } while (pasirinkimas < min || pasirinkimas > max);
    return pasirinkimas;
}
// *****************************************************************************
void AutomobiliuSarasas::printBendrasAutoukioIslaidas () {
    string dataNuo, 
           dataIki;
    double bendraSuma = 0.0;
    
    cout << "Iveskite laikotarpi NUO (yyy-mm-dd): ";   cin >> dataNuo;
    cout << "Iveskite laikotarpi IKI (yyy-mm-dd): ";   cin >> dataIki;
    
    for (vector<Automobilis*>::iterator iter = automobiliai.begin(); iter != automobiliai.end(); iter++) {
        bendraSuma += (*iter)->getLaikotarpis(dataNuo, dataIki);
    }
    cout << "Laikotarpis nuo - iki            Islaidos" << endl;  
    cout << "[" << dataNuo << "] - [" << dataIki << "]    " << bendraSuma << endl;
    system("pause");
}

